<?php

namespace Drupal\mymodule\Plugin\rest\resource;

use Drupal\rest\Plugin\ResourceBase;
use Drupal\rest\ResourceResponse;

/**
 * Provides a resource to get people
 *
 * @RestResource(
 *   id = "get_people",
 *   label = @Translation("Get people"),
 *   uri_paths = {
 *     "canonical" = "/api/people"
 *   }
 * )
 */
class GetPeople extends ResourceBase {

  public function get() {

    $query = \Drupal::request()->query;
    $nodes = \Drupal::entityTypeManager()
      ->getStorage('node')
      ->loadByProperties([
        'type' => 'people'
      ]);

    $response['count'] = count($nodes);
    $response['next'] = '';
    $response['previous'] = '';
    $response['query'] = $query;

    foreach ($nodes as $node) {
      if (count($response['results']) < 11) {
        $result['name'] = $node->label();
        $result['height'] = $this->getFieldValue($node->field_height->getValue());
        $result['mass'] = $this->getFieldValue($node->field_mass->getValue());
        $result['hair_color'] = $this->getFieldValue($node->field_hair_color->getValue());
        $result['skin_color'] = $this->getFieldValue($node->field_skin_color->getValue());
        $result['eye_color'] = $this->getFieldValue($node->field_eye_color->getValue());
        $result['birth_year'] = $this->getFieldValue($node->field_birth_year->getValue());
        $result['gender'] = $this->getFieldValue($node->field_gender->getValue());

        $node_homeworld = $node->field_homeworld;
        $result['homeworld'] = $node_homeworld;

        $response['results'][] = $result;
      }
    }

    return new ResourceResponse($response);
  }

  public function getFieldValue($value) {
    $value = $value[0]['value'];
    return $value;
  }

  public function permissions()
  {

  }
}
